# ARST打卡第220周[220/521]

<!--more-->

## Algorithm
lc860_柠檬水找零

思路: 
因为相同金额下，小的零钱永远是能够拼凑出这个金额，而且还能做其他找零，所以优先级更高，所以贪心先找零大钱即可。
对于每次交易分情况判断即可。

1把AC了，然后看了一下，发现自己和题解思路一样，但是自己多用了一个20元的变量，可以优化掉。

```cpp
class Solution {
public:
    bool lemonadeChange(vector<int>& bills) {
        // 代表 5,10,20 刀的计数---可以优化成只有5,10刀的两个变量
        int cnt[3] = {0, 0, 0};
        for (auto& x : bills) {
            if (5 == x) {
                cnt[0]++;
            } else if (10 == x) {
                if (!cnt[0]) {
                    return false;
                }
                cnt[0]--;
                cnt[1]++;
            } else {
                if (!cnt[1]) {
                    if (cnt[0] < 3) {
                        return false;
                    }
                    cnt[0] -= 3;
                    cnt[2]++;
                } else {
                    if (!cnt[0]) {
                        return false;
                    }
                    // 有10元就优先花掉一张10元
                    cnt[0]--;
                    cnt[1]--;
                    cnt[2]++;
                }
            }
        }
        return true;
    }
};
```

## Review
【TED演讲】克服恐惧、自我怀疑和焦虑

<div align = "center">
    <iframe  width="100%" height="700" src="//player.bilibili.com/player.html?aid=488589250&bvid=BV1QN4112786&cid=1201494769&page=1" frameborder="0" allow="autoplay; encrypted-media" allowfullscreen></iframe>
</div>

鼓起勇气直面恐惧，然后去接纳它，从而去一步步解决它

## Tips
[为什么要自研RPC框架？HTTP和RPC的区别](https://juejin.cn/post/7100602664534147079)
[HTTP 与 RPC 接口区别](https://apifox.com/apiskills/http-vs-rpc/)

## Share 勇气的源泉 读书分享
下面是一些个人感想和优秀书摘
### 个人感想
本书前面虽然花了很大篇幅讲精神官能症，有点枯燥乏味，但是后面引出的赋予勇气很是有帮助

以下是我个人感悟或者得到思维强化的一些观点分享: 

- 用目的论分析动机，而不是用原因论分析成因
  - 每个人都想要获得善(对自己有好处)
- 不在乎别人的看法，被讨厌的勇气
  - 不害怕他人的评价，就能有勇气去做那些可能会失败但有价值的事情
  - 每个人都不是世界的中心，不用把自己看得太重要，也有利于共同体的感觉以及有利于不害怕别人的评价
- 对于自己没法控制的事情，保持为而不争的态度就好，努力去做好，但是不在乎结果
- 勇敢地活在当下，不要为了防止未来可能的失败而焦虑地放弃，从而达到自己没努力而已的心理安慰的善(面向未来的目的论)
- 共同体，不求回报对他人好，只是为了获取对共同体贡献的感觉
  - 给共同体做过贡献，也就不怕死亡没留下任何东西了
- 从存在层面看，你存在就对他人有价值，从行动层面看，你的贡献对他人有价值
  - 亲人存在就有价值的预期，能让你友好地对待任何行为
- 不赞扬，不批评，平等对待每一个人(平等就不会辱骂了)，包括所有的小孩和弱势群体
- 人生有很多意外，很多无意义的事情，但是这些我们无法改变的，就接纳，然后去给自己的人生赋予意义
- 活着很辛苦没错，但是活着的喜悦也让人安慰，珍惜每一个当下
- 心理学不是一蹴而就的，需要不断在生活中实践，尽量去让自己活得更好，更安宁

### 只有觉得有价值才会鼓起勇气
阿德勒说：“我只有在觉得自己有价值的时候才会鼓起勇气。”

当孩子回避人生的问题，与其说是问题本身很困难，不如说是因为他认为自己没有价值。当然，孩子所面对的问题当中，一定有很困难的问题，甚至有时候会遇到他根本解决不了的问题。但是，任何人都会遇到困难的问题，这时候与其认为自己解决不了，不如说是他觉得自己没有价值，所以面对问题时无法提起勇气。

### 不害怕失败
假如上述的论点正确，被赋予勇气的孩子不会害怕失败，他会依照自己的判断行动，因为他喜欢为他人作出贡献，并且从不感到厌倦，和那些只考虑自己，一失败就担心别人对自己的评价的孩子完全不同。

**被赋予勇气的孩子，只会关心一件事，那就是怎么解决问题。但是害怕失败的孩子不但不会解决问题，还只会关心自己。他们在意别人对自己的评价，害怕失败，害怕到甚至不愿试着去解决问题。被赋予勇气的孩子们则不会这么想。他们不在意别人的评价，即使解决问题了，也不会借此炫耀，或表现出自己很厉害的样子。他们从不用可能性作为借口逃避问题，或认为“我现在只是不想做而已，只要我想做就一定做得到”。**

总之，这些孩子遇到问题，就会从做得到的地方开始，一点一滴地去解决。这就是勇气，阿德勒把这种勇气称作“不完全的勇气”“失败的勇气”。这比起害怕失败、连跨出第一步试着解决问题都不敢要好太多了。不断重复同样的失败确实是个问题，但没有失败就学不到任何东西。考完试后立刻对答案的人可以避免下次犯下同样的错误，若不敢直视自己人生的缺点和错误，重新改过，下次还是会犯同样的错。

### 其他书摘
- 与其直接肯定人生发生的所有事情都有意义，不如想办法超越不合理，努力把人生变得有意义，这才是有意义的人生。
- 只要目标明确，即使已经下定决心开始做的事情因为某种原因无法持续做下去，也能明白过去所作的努力，都是为了达成目标的手段，因此做得不顺利、碰壁了，也不必固执，转而做别的事情就好。如果认为决定的事情最后一定要成功，这样的固执有可能到最后只是徒劳无功。只要内心清楚明白，自己决定要做的事情并不是终极目标，这样你就有勇气改变决心。


